param n := read "entrada_torneo.in" as "1n" use 1; # Cantidad de equipos
param k := read "entrada_torneo.in" as "1n" skip 1 use 1; # Posicion a analizar
param r := read "entrada_torneo.in" as "1n" skip 2 use 1; # Cantidad de rondas
param M := (3*r*n+1); # Cota del total de puntos que puede sacar un equipo

set equipos := {1..n};

var x[equipos*equipos] integer; # Cantidad de veces que i le gano a j 
var p[equipos] integer; # Puntaje del equipo i 
var I[equipos] binary; # I[i] = 1 <=> P[i] >= P[1]

maximize puntaje : p[1]; # Poner minimize para el otro problema

subto posicion : 
	( sum <i> in equipos with i >= 2 : I[i] ) >= k-1; # Poner <= para el otro problema
 
subto puntaje :
	forall <i> in equipos :
		(sum <j> in equipos with i != j : (3*x[i,j]+(r-x[i,j]-x[j,i])) ) == p[i];
		
subto rondas_1 :
	forall <i,j> in equipos*equipos :
		x[i,j] >= 0;
		
subto rondas_2 :
	forall <i,j> in equipos*equipos :
		x[i,j] <= r;
	
subto rondas_3 :
	forall <i,j> in equipos*equipos :
		x[i,j] + x[j,i] <= r;
		
subto indicadoras_1:
	forall <i> in equipos:
		p[i] >= p[1] - M*(1-I[i]); # Agregar + 1 en el lado derecho para el otro problema

subto indicadoras_2:
	forall <i> in equipos:
		p[1] >= p[i] - M*I[i] + 1; # Sacar el + 1 del lado derecho para el otro problema		
	
		
